
var point = func()
{
	return { var x = 0, var y = 0 };
};

var MidHandle = func( image )
{
	image.SetHandle(image.Width * 0.5, image.Height * 0.5);
};

var calculateAngle = func( x1, y1, x2, y2 )
{
	var theX = x1 - x2;
	var theY = y1 - y2;
	var theAngle = -atan2(theX, theY);
	return theAngle;
};

var BlobMonster =
{
	var New = func( inx, iny, inimage )
	{
		var bm =
		{
			var x = inx,
			var y = iny,
			var speed = 1,
			var segments = 10,
			var tail = [0],
			var time = 0,
			var blob = inimage,
			
			var ctor = &BlobMonster.ctor,
			var Update = &BlobMonster.Update,
			var Draw = &BlobMonster.Draw
		};
		
		bm.ctor();
		
		return bm;
	},
	
	var ctor = func()
	{
		tail.length = segments;
		
		for (var i = 0; i < segments; i++)
		{
			tail[i] = point();
			tail[i].x = x;
			tail[i].y = y;
		}
	},
	
	var Update = func()
	{
		time += speed;
		
		y = (15 * cos(time * -6)) + (device_height()/2 + (180 * sin(time * 1.3)));
		x = (15 * sin(time * -6)) + (device_width()/2 + (200 * cos(time / 1.5)));
		
		tail[0].x = x;
		tail[0].y = y;
		
		for (var i = 1; i < segments; i++)
		{
			var distX = tail[i - 1].x - tail[i].x;
			var distY = tail[i - 1].y - tail[i].y;
			var dist = sqrt(distX * distX + distY * distY);
			
			if ( dist > 7 )
			{
				tail[i].x = tail[i].x + (distX * 0.3);
				tail[i].y = tail[i].y + (distY * 0.3);
			}
		}
	},
	
	var Draw = func()
	{
		set_blend(1);
		
		blob.SetHandle(blob.Width * 0.5, blob.Height * 0.5);
		
		for (var i = 0; i < segments; i++)
		{
			set_alpha(0.15);
			DrawImage(blob, tail[i].x, tail[i].y, 0, 1 + (0.5 * sin(i * 35)), 1 + (0.5 * sin(i * 35)));
			set_alpha(0.8);
			DrawImage(blob, tail[i].x, tail[i].y, 0, 0.1, 0.1);
		}
		
		blob.SetHandle(0, blob.Height * 0.5);
		
		DrawImage(blob, tail[segments - 1].x, tail[segments - 1].y,10 * sin(time * 10) + -calculateAngle(tail[segments - 1].x, tail[segments - 1].y, tail[segments - 5].x, tail[segments - 5].y) + 270,0.6, 0.1);
		DrawImage(blob, tail[segments - 1].x, tail[segments - 1].y,10 * sin(-time * 10) + -calculateAngle(tail[segments - 1].x, tail[segments - 1].y, tail[segments - 5].x, tail[segments - 5].y) + 270,0.6, 0.1);
		
		set_alpha(1);
		
		for (var i = 1; i < segments - 1; i++)
		{
			DrawImage(blob, tail[i].x, tail[i].y,33 * sin(time * 5 + i * 30) + -calculateAngle(tail[i].x, tail[i].y, tail[i - 1].x, tail[i - 1].y),0.1 + (0.6 * sin(i * 30)), 0.05);
			DrawImage(blob, tail[i].x, tail[i].y,33 * sin(-time * 5 - i * 30) + -calculateAngle(tail[i].x, tail[i].y, tail[i - 1].x, tail[i - 1].y) + 180,0.1 + (0.6 * sin(i * 30)), 0.05);
		}
		
		MidHandle(blob);
		set_alpha(0.1);
		
		var ang = calculateAngle(tail[0].x, tail[0].y, tail[1].x, tail[1].y);
		DrawImage(blob, x + (7 * cos(ang + 50)), y + (7 * sin(ang + 50)),0,0.6, 0.6);
		DrawImage(blob, x + (7 * cos(ang + 140)), y + (7 * sin(ang + 140)),0,0.6, 0.6);
		
		set_alpha(0.5);
		DrawImage(blob, x + (7 * cos(ang + 50)), y + (7 * sin(ang + 50)),0,0.1, 0.1);
		DrawImage(blob, x + (7 * cos(ang + 140)), y + (7 * sin(ang + 140)),0,0.1, 0.1);
		
		set_alpha(0.8);
		blob.SetHandle(0, blob.Height * 0.5);
		
		DrawImage(blob, x, y, -ang + 275, 0.3, 0.1);
		
		MidHandle(blob);
		set_alpha(0.2);
		DrawImage(blob, x, y, 0, 4, 4);
	}
};

blobimage = LoadImage("blob.png");
theMonster = BlobMonster.New(10, 10, blobimage);

while (true)
{
	theMonster.Update();
	theMonster.Draw();
	yield;
}

yield false;
