Import minic
Import mcbindings ' get here https://bitbucket.org/Goodlookinguy/minic-commonbindings
Import mojo

#TEXT_FILES+="*.mc"

Function Main()
	New Example()
End

Class MCImage Implements IVMObjectInterface
	Method VMSet:VMValue( scope:VMScope, varName:String, data:VMValue )
		'Select varName
			
		'End
		
		Return Null
	End
	
	Method VMGet:VMValue( scope:VMScope, varName:String )
		Select varName
			Case "HandleX"	Return VMValue.CreateFloat(image.HandleX())
			Case "HandleY"	Return VMValue.CreateFloat(image.HandleY())
			Case "Width"	Return VMValue.CreateFloat(image.Width())
			Case "Height"	Return VMValue.CreateFloat(image.Height())
			Case "Frames"	Return VMValue.CreateFloat(image.Frames())
		End
		
		Return Null
	End
	
	Method VMCall:VMValue( scope:VMScope, varName:String, params:VMValue[] )
		Select varName
			Case "SetHandle"
				If params.Length < 2
					scope.RuntimeErr("Image.SetHandle takes 2 arguments")
				End
				
				image.SetHandle(params[0].dataFloat, params[1].dataFloat)
		End
		
		Return Null
	End
	
	Field image:Image
End


Class MCLoadImageDelegate Implements IVMDelegate
	Method Exec:VMValue(scope:VMScope, params:VMValue[])
		EnsureParamLength(params, 1, 5, "LoadImage")
		Local mcImage:MCImage = New MCImage()
		
		Select params.Length()
			Case 5
				mcImage.image = LoadImage(params[0].dataStr, Int(params[1].dataFloat), Int(params[2].dataFloat),
					Int(params[3].dataFloat), Int(params[4].dataFloat))
				Return VMValue.CreateObject(mcImage)
			Case 4
				mcImage.image = LoadImage(params[0].dataStr, Int(params[1].dataFloat), Int(params[2].dataFloat),
					Int(params[3].dataFloat))
				Return VMValue.CreateObject(mcImage)
			Case 3
				mcImage.image = LoadImage(params[0].dataStr, Int(params[1].dataFloat), Int(params[2].dataFloat))
				Return VMValue.CreateObject(mcImage)
			Case 2
				mcImage.image = LoadImage(params[0].dataStr, Int(params[1].dataFloat))
				Return VMValue.CreateObject(mcImage)
		End
		
		mcImage.image = LoadImage(params[0].dataStr)
		Return VMValue.CreateObject(mcImage)
	End 
End

Class MCDrawImageDelegate Implements IVMDelegate
	Method Exec:VMValue(scope:VMScope, params:VMValue[])
		EnsureParamLength(params, 3, 7, "DrawImage")
		
		Select params.Length()
			Case 7
				Return VMValue.CreateFloat(DrawImage(MCImage(params[0].dataObject).image, params[1].dataFloat, params[2].dataFloat,
					params[3].dataFloat, params[4].dataFloat, params[5].dataFloat, Int(params[6].dataFloat)))
			Case 6
				Return VMValue.CreateFloat(DrawImage(MCImage(params[0].dataObject).image, params[1].dataFloat, params[2].dataFloat,
					params[3].dataFloat, params[4].dataFloat, params[5].dataFloat))
			Case 5
				EnsureParamLength(params, 6, 7, "DrawImage") ' there is no 5 parameter overload of DrawImage
			Case 4
				Return VMValue.CreateFloat(DrawImage(MCImage(params[0].dataObject).image, params[1].dataFloat, params[2].dataFloat,
					Int(params[3].dataFloat)))
		End
		Return VMValue.CreateFloat(DrawImage(MCImage(params[0].dataObject).image, params[1].dataFloat, params[2].dataFloat))
	End 
End


Class Example Extends App
	Field blobScript:VMScope
	Field astvm:VM
	Field script:String
	
	Method OnCreate()
		SetUpdateRate(60)
		astvm = new VM()
		
		InitalizeTheBlob()
	End
	
	Method InitalizeTheBlob:Void()
		script = LoadString("blobmonster2.mc")
		blobScript = astvm.LoadScript(script, Null, "blobmonster2.mc")
		
		If blobScript.body <> Null
			MCRegisterMonkey(blobScript)
			MCRegisterExtra(blobScript)
			MCRegisterMojoExtra(blobScript)
			MCRegisterString(blobScript)
			MCRegisterMojo(blobScript)
			
			blobScript.Register("LoadImage", New MCLoadImageDelegate())
			blobScript.Register("DrawImage", New MCDrawImageDelegate())
		End
	End
	
	Method OnUpdate:Int()
		If KeyDown(KEY_R)
			InitalizeTheBlob()
		End
	End
	
	Method OnRender:Int()
		Cls()
		
		blobScript.Exec()
	End
End
